package com.duke.fuzzy_plugin;

import androidx.annotation.NonNull;

import com.duke.fuzzy_plugin.channel.GetFuzzySystems;
import com.duke.fuzzy_plugin.channel.LoadFuzzySystems;

import io.flutter.embedding.engine.FlutterEngine;
import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;

/** FuzzyPlugin */
public class FuzzyPlugin implements FlutterPlugin, MethodCallHandler {
  /// The MethodChannel that will the communication between Flutter and native Android
  ///
  /// This local reference serves to register the plugin with the Flutter Engine and unregister it
  /// when the Flutter Engine is detached from the Activity
  private MethodChannel channel;
  private MethodChannel channel2;
  private MethodChannel channel3;


  private static FuzzyLibraryController controller = FuzzyLibraryController.getInstance();

  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "fuzzy_plugin");
    channel.setMethodCallHandler(this);

    channel2 = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "fuzzy_plugin_load");
    channel2.setMethodCallHandler(new LoadFuzzySystems());

    channel3 = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "fuzzy_plugin_get_fuzzy_systems");
    channel3.setMethodCallHandler(new GetFuzzySystems());

  }

  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {

    switch (call.method){
      case "getPlatformVersion":
        result.success("Android " + android.os.Build.VERSION.RELEASE);
        break;
      default: result.notImplemented();
    }

  }

  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMethodCallHandler(null);
  }
}
