import 'dart:async';
import 'dart:ffi';

import 'package:flutter/services.dart';

class FuzzyPlugin {
  static const MethodChannel _channel = MethodChannel('fuzzy_plugin');
  static const MethodChannel _channel_get_systems =
      MethodChannel('fuzzy_plugin_get_fuzzy_systems');
  static const MethodChannel _channel_load = MethodChannel('fuzzy_plugin_load');

  static Future<String?> get platformVersion async {
    final String? version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<List<String>> fuzzySystems() async {
    final List<dynamic>? systems =
        await _channel_load.invokeListMethod("getFuzzySystems");
    return systems!.cast<String>();
  }

  static Future<bool> load(String json) async {
    final bool success =
        await _channel_get_systems.invokeMethod("load", {"json": json});
    return success;
  }
}
